Bug 1851532 - BMO can get into hot reconcile loop when changing Status
Summary: BMO can get into hot reconcile loop when changing Status
Keywords:
Status: CLOSED WONTFIX
Alias: None
Product: OpenShift Container Platform
Classification: Red Hat
Component: Bare Metal Hardware Provisioning
Version: 4.4
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: ---
: 4.4.z
Assignee: Zane Bitter
QA Contact: Raviv Bar-Tal
URL:
Whiteboard:
Depends On: 1851531
Blocks:
TreeView+ depends on / blocked
 
Reported: 2020-06-26 20:37 UTC by Zane Bitter
Modified: 2020-11-12 14:54 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of: 1851531
Environment:
Last Closed: 2020-11-12 14:54:17 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Github openshift baremetal-operator pull 94 0 None closed Bug 1851532: Do not write status annotation 2020-12-02 08:43:06 UTC

Description Zane Bitter 2020-06-26 20:37:06 UTC
+++ This bug was initially created as a clone of Bug #1851531 +++

+++ This bug was initially created as a clone of Bug #1851530 +++

Description of problem:
As described in: https://github.com/metal3-io/baremetal-operator/pull/565

The code to write the 'status' annotation (an annotation containing the Status data) whenever the status changes can cause an infinite hot loop. Since the annotation and the Status subresource cannot be written at the same time, we re-read the object after writing the annotation and before trying to write the Status. However, if we get a previously cached version then there will be an error and we'll begin the Reconcile cycle again. The new Status changes generated by this new Reconcile may contain different timestamps, which will result in the annotation being updated and the whole cycle repeating. Rate limiting helps to ensure that once this happens once the timestamps only get further and further apart, so the loop is self-sustaining.

We don't actually need or want to write a status annotation. We want to be able to *read* one, and we backported the code to do so to both 4.5 (bug 1835457) and 4.4 (bug 1843230). However, the code to both read and create the annotation was in the same patch, so we ended up with both.

Comment 2 Zane Bitter 2020-11-12 14:47:31 UTC
Not required in 4.4.


Note You need to log in before you can comment on or make changes to this bug.